library DBXFmt;
  {&H-,Use32+,StdCall+,D-,LocInfo-}
uses
    Plugin,
    FMT,
    DbxOut,
    MyUtils,
{$IFDEF VPASCAL}
    Strings,
{$ELSE}
    SysUtils,
{$ENDIF}
    Windows;

var
   hDBX: THDBX;
   MsgCount, MsgCurrent: LongInt;
   ModuleName: array[1..MAX_PATH] of Char;

{$IFDEF VPASCAL}
  {$L DllInit.obj}
{$ENDIF}

function LoadFormatModule(NewModuleName: PChar): LongInt; StdCall;
begin
     GetShortPathName(NewModuleName, @ModuleName, sizeof(ModuleName));
     Result:=0;
end;

function IsArchive(const Name: PChar; const Data: PChar; DataSize: DWORD): LongInt; StdCall;
type
    TArr = array[0..19] of Byte;
const
     ctDBXSig: TArr = ($CF, $AD, $12, $FE, $C5, $FD, $74, $6F, $66, $E3, $D1, $11, $9A, $4E, $00, $C0, $4F, $A3, $09, $D4);
var
   I: Byte;
begin
     I:=0;
     if DataSize>=20 then while (I<20) and (Byte(Data[I])=ctDBXSig[I]) do Inc(I);
     if I=20 then
       Result:=LongInt(True)
     else
       Result:=LongInt(False);
end;

function OpenArchive(const Name: PChar; var aType: DWORD): LongInt; StdCall;
begin
     hDBX:=DBXOpen(Name);
     if hDBX<>DBXError then
       begin
            aType:=0;
            MsgCount:=DBXGetMsgCount(hDBX);
            MsgCurrent:=0;
            Result:=LongInt(True);
       end
     else
       Result:=LongInt(False);
end;

function GetArcItem(var Item: TPluginPanelItem; var Info: TArcItemInfo): Integer; StdCall;
const
     ctNoSubject = '(NoSubject)';
     ctNoName = '(NoName)';
var
   pDBXLockData: TPDBXLockData;
   pSubject, pFromName: PChar;
   pTmp: PChar;
   pFT: PFileTime;
begin

     if MsgCurrent<MsgCount then
       begin
            pDBXLockData:=DBXLockMsgHeaderByPos(hDBX, MsgCurrent);

            pSubject:=DBXGetOSubject(TPDBXHeaderData(pDBXLockData));
            if lstrlen(pSubject)=0 then pSubject:=ctNoSubject;

            pFromName:=DBXGetFromName(TPDBXHeaderData(pDBXLockData));
            if lstrlen(pFromName)=0 then
            begin
              pFromName:=DBXGetFromAddres(TPDBXHeaderData(pDBXLockData));
              if lstrlen(pFromName)=0 then pFromName:=ctNoName;
            end;


            Item.FindData.nFileSizeHigh:=0;
            Item.FindData.nFileSizeLow:=DBXGetMsgSize(TPDBXHeaderData(pDBXLockData));

            pFT:=DBXGetTimeSend(TPDBXHeaderData(pDBXLockData));
            if pFT=nil then pFT:=DBXGetTimeRecieved(TPDBXHeaderData(pDBXLockData));
            Item.FindData.ftLastWriteTime:=pFT^;

//            Item.FindData.ftLastWriteTime:=DBXGetTimeSend(TPDBXHeaderData(pDBXLockData))^;

            pTmp:=StrCopySpec(Item.FindData.cFileName, pSubject);
            pTmp^:='\';
            Inc(pTmp);
            pTmp:=StrCopySpec(pTmp, pFromName);
            pTmp:=StrCopySpec(pTmp, '                        ');
            LongIntToHex(MsgCurrent, pTmp);
            Inc(pTmp, 8);
            lstrcpy(pTmp, '.msg');

            CharToOEM(Item.FindData.cFileName, Item.FindData.cFileName);

            DBXUnlock(pDBXLockData);

            Inc(MsgCurrent);
            Result:=GETARC_SUCCESS;
       end
     else
       Result:=GETARC_EOF;
end;

function CloseArchive(var Info: TArcInfo): LongInt; StdCall;
begin
     Result:=LongInt(DBXClose(hDBX)<>DBXERROR);
end;

function GetFormatName(aType: DWORD; FormatName, DefaultExt: PChar): LongInt; StdCall;
begin
     if aType=0 then
       begin
            FormatName:=lstrcpy(FormatName, 'OE Message Base');
            DefaultExt:=lstrcpy(DefaultExt, 'DBX');
            Result:=LongInt(True);
       end
     else
       Result:=LongInt(False);
end;

function GetDefaultCommands(aType: DWORD; Command: DWORD; Dest: PChar): LongInt; StdCall;
begin
     Result:=LongInt(False);
     if aType=0 then
       begin
         if Command=1 then
           begin
                Dest:=lstrcat(lstrcat(lstrcat(Dest, 'RunDll32 '), @ModuleName), ',Extract %%a %%fW');
           end;
         Result:=LongInt(True);
       end;
end;

function Extract(ahWnd: HWND; hInstance: HINST; CmdLine: PChar; dummy: LongInt): LongInt; StdCall;
var
   DBXName: array[1..MAX_PATH] of Char;
   MsgNum: LongInt;
   pMsgName: PChar;
   hDBXNew: THDBX;
begin
     StrLCopy(@DBXName, CmdLine, StrScan(CmdLine, ' ')-CmdLine);
     pMsgName:=CmdLine+lstrlen(CmdLine)-12;
     MsgNum:=HexToLongInt(pMsgName);
     hDBXNew:=DBXOpen(@DBXName);


     DBXSaveAsMsgByPos(hDBXNew, MsgNum, pMsgName);
     DBXClose(hDBXNew);

end;

exports
  LoadFormatModule,
  IsArchive,
  OpenArchive,
  GetArcItem,
  CloseArchive,
  GetFormatName,
  GetDefaultCommands,
  Extract;

Begin
End.
