unit DbxOut;
interface

uses
    Windows;

const
     DBXERROR = $FFFFFFFF;  //common error code

type
  {$IFDEF VER100}
    LPTSTR = PChar;
    LPCTSTR = PChar;
  {$ENDIF}
    THDBX = THandle;

    TPDBXLockData = ^TDBXLockData;
    TDBXLockData = record
      dwSizeLocked: DWORD;
      pbData: ^Byte;
    end;

    TPDBXHeaderData = TPDBXLockData;

  function DBXGetTimeRecieved(pData: TPDBXHeaderData): PFileTime; cdecl;
  function DBXGetTimeSend(pData: TPDBXHeaderData): PFileTime; cdecl;

//up-level functions
  function DBXLockMsgHeaderByPos(hDBX: THDBX; dwMsgPos: DWORD): TPDBXLockData; cdecl;
//PDBX_LOCK_DATA DBXOUT_API DBXLockMsgHeaderByID(HDBX hDBX,DWORD dwMsgID);
//Always call DBXUnlock after using PDBX_LOCK_DATA returnned by DBXLockXXX
  procedure DBXUnlock(pDLD: TPDBXLockData); cdecl;

  function DBXAlloc(dwSize: DWORD): pointer; cdecl;
  procedure DBXFree(pPtr: pointer); cdecl;

  function DBXOpen(pszFullPathName: pChar): THDBX; cdecl;
  function DBXIsMessageDatabase(hDBX: THDBX): Boolean; cdecl;
  function DBXClose(hDBX: THDBX): DWORD; cdecl;

  function DBXGetMsgCount(hDBX: THDBX): DWORD; cdecl;

  function DBXGetMsgHeaderByPos(hDBX: THDBX; dwMsgPos: DWORD; pszBuffer: LPTSTR; var pcbBuffer: DWORD): DWORD; cdecl;
  function DBXGetMsgByPos(hDBX: THDBX; dwMsgPos: DWORD; pszBuffer: LPTSTR; var pcbBuffer: DWORD): DWORD; cdecl;

  function DBXSaveMsgByPos(hDBX: THDBX; dwMsgPos: DWORD): DWORD; cdecl;

  function DBXSaveAsMsgByPos(hDBX: THDBX; dwMsgPos: DWORD; pszFileName: LPCTSTR): DWORD; cdecl;

  function DBXGetOSubject(pData: TPDBXHeaderData): PChar;
  function DBXGetFromName(pData: TPDBXHeaderData): PChar;
  function DBXGetFromAddres(pData: TPDBXHeaderData): PChar;
  function DBXGetMsgSize(pData: TPDBXHeaderData): LongInt;
  function DBXGetMsgID(pData: TPDBXHeaderData): LongInt;

implementation

function GetAddr(pData: TPDBXHeaderData; ID: Byte): pointer;
var
   PropertyCount, I: Byte;
   pCurData: pointer;
begin
  Result:=nil;
  pCurData:=pData^.pbData;
  Inc(DWORD(pCurData), 10);
  PropertyCount:=byte(pCurData^);
  Inc(DWORD(pCurData), 2);
  for I:=0 to PropertyCount-1 do
  begin
    if (Byte(pCurData^) and $7F)=ID then
      begin
         Result:=Pointer(DWORD(pCurData^) shr 8);
         if (Byte(pCurData^) and $80)=0 then
           Result:=Pointer(DWORD(Result)+PropertyCount*4+12+DWORD(pData^.pbData));
         Break;
      end
    else
      Inc(DWORD(pCurData), 4);
  end
end;


  function DBXLockMsgHeaderByPos; external 'DBXOut.dll' name 'DBXLockMsgHeaderByPos';
  procedure DBXUnlock; external 'DBXOut.dll' name 'DBXUnlock';

  function DBXAlloc; external 'DBXOut.dll' name 'DBXAlloc';
  procedure DBXFree; external 'DBXOut.dll' name 'DBXFree';

  function DBXOpen; external 'DBXOut.dll' name 'DBXOpen';
  function DBXIsMessageDatabase;  external 'DBXOut.dll' name 'DBXIsMessageDatabase';
  function DBXClose; external 'DBXOut.dll' name 'DBXClose';

  function DBXGetMsgCount; external 'DBXOut.dll' name 'DBXGetMsgCount';

  function DBXGetMsgHeaderByPos; external 'DBXOut.dll' name 'DBXGetMsgHeaderByPos';
  function DBXGetMsgByPos; external 'DBXOut.dll' name 'DBXGetMsgByPos';

  function DBXSaveMsgByPos; external 'DBXOut.dll' name 'DBXSaveMsgByPos';

  function DBXSaveAsMsgByPos; external 'DBXOut.dll' name 'DBXSaveAsMsgByPos';

function DBXGetTimeRecieved(pData: TPDBXHeaderData): PFileTime;
begin
     Result:=GetAddr(pData, $12);
end;

function DBXGetTimeSend(pData: TPDBXHeaderData): PFileTime;
begin
     Result:=GetAddr(pData, 2);
end;

function DBXGetOSubject(pData: TPDBXHeaderData): PChar;
begin
     Result:=GetAddr(pData, 5);
end;

function DBXGetFromName(pData: TPDBXHeaderData): PChar;
begin
     Result:=GetAddr(pData, $D);
end;

function DBXGetFromAddres(pData: TPDBXHeaderData): PChar;
begin
     Result:=GetAddr(pData, $E);
end;

function DBXGetMsgSize(pData: TPDBXHeaderData): LongInt;
begin
     Result:=LongInt(GetAddr(pData, $11));
end;

function DBXGetMsgID(pData: TPDBXHeaderData): LongInt;
begin
     Result:=LongInt(GetAddr(pData, 0));
end;

end.
