unit MyUtils;

{$IFDEF VPASCAL}
  {&H-,Use32+}
{$ELSE}
  {$ALIGN OFF}
  {$MINENUMSIZE 4}
{$ENDIF}

interface

  function HexToLongInt(Hex: PChar): LongInt;
  function LongIntToHex(L: LongInt; Hex: PChar): PChar;
  function StrCopySpec(Dest, Source: PChar): PChar;

implementation

function HexToLongInt(Hex: PChar): LongInt;
var
   I: Byte;
begin
     Result:=0;
     for I:=0 to 7 do
     begin
          Result:=Result shl 4;
          case UpCase(Hex[I]) of
            '0'..'9': Result:=Result or (Ord(UpCase(Hex[I]))-Ord('0'));
            'A'..'F': Result:=Result or (Ord(UpCase(Hex[I]))-Ord('A')+10);
          end;
     end;
end;

function LongIntToHex(L: LongInt; Hex: PChar): PChar;
const
     dig: array[0..17] of char = '0123456789ABCDEF';
var
   I: Byte;
begin
     for I:=7 downto 0 do
     begin
          Hex[I]:=Dig[L and $F];
          L:=L shr 4;
     end;
     Hex[8]:=#0;
     Result:=Hex;
end;

function StrCopySpec(Dest, Source: PChar): PChar;
var
   I: LongInt;
begin
     I:=0;
     while not (Source[I] in [#$D, #$A, #0]) do
     begin
          if Source[I] in ['\', '/'] then
            Dest[I]:='|'
          else
            Dest[I]:=Source[I];
          Inc(I);
     end;
     Dest[I]:=#0;
     Result:=@Dest[I];
end;

end.
